// STK_test
// John Ellinger, MUSC 208, Spring 2013

// Declare 21 STK instrumets but don't send them to dac, yet
BandedWG stk0;
BlowBotl stk1;
BlowHole stk2;
Bowed stk3;
Brass stk4;
Clarinet stk5;
Flute stk6;
BeeThree  stk7;
FMVoices  stk8;
HevyMetl  stk9;
PercFlut  stk10;
Rhodey  stk11;
TubeBell  stk12;
Wurley stk13;
Mandolin stk14;
ModalBar stk15;
Moog stk16;
Saxofony stk17;
Shakers stk18;
Sitar stk19;
StifKarp stk20;
VoicForm stk21;

// declare an array holding the 21 instruments
// Every individual STK instrument is a sublcass
// of StkInstrument
[
stk0,
stk1,
stk2,
stk3,
stk4,
stk5,
stk6,
stk7,
stk8,
stk9,
stk10,
stk11,
stk12,
stk13,
stk14,
stk15,
stk16,
stk17,
stk18,
stk19,
stk20,
stk21
] @=> StkInstrument stk[];

// This is an arry of names that match the
// instruments used above. For printout purposes
[
"BandedWG",
"BlowBotl",
"BlowHole",
"Bowed",
"Brass",
"Clarinet",
"Flute",
"BeeThree ",
"FMVoices ",
"HevyMetl ",
"PercFlut ",
"Rhodey ",
"TubeBell ",
"Wurley",
"Mandolin",
"ModalBar",
"Moog",
"Saxofony",
"Shakers",
"Sitar",
"StifKarp",
"VoicForm"
] @=> string stkNames[];

// An extended C major scale
// Not all notes sound good in
// all STK instruments
// Some STK instruments are out of tune
[ 
36, 38, 40, 41, 43, 45, 47, 
48, 50, 52, 53, 55, 57, 59,
60, 62, 64, 65, 67, 69, 71,
72, 74, 76, 77, 79, 81, 83, 
84, 86, 88, 89, 91, 93, 95, 96 
] @=> int cmajor[];

// This is the function used in the for loop
// to play all 21 instruments.
// the name of each instrument will appear in
// in the console monitor window as it plays
function void playStkInstrument( StkInstrument stk )
{
    stk => dac; // connect
    0.4 => stk.gain;
    300::ms => dur beat;
    
    for ( 0 => int ix; ix < cmajor.cap(); ix++ )
    {
        Std.mtof( cmajor[ix] ) => stk.freq;
        .5 => stk.noteOn;
        beat => now;
    } 

    stk =< dac; // disconnect
}

for ( 0 => int ix; ix < stk.cap(); ix++ )
{
    <<< ix, stkNames[ix] >>>;
    playStkInstrument( stk[ix] );
}

